Package org.optaplanner.core.impl.score.director.drools.testgen

## Class TestGenDroolsScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory<Solution_,​Score_>
  - - org.optaplanner.core.impl.score.director.drools.DroolsScoreDirectorFactory<Solution_,​Score_>
    - - org.optaplanner.core.impl.score.director.drools.testgen.TestGenDroolsScoreDirectorFactory<Solution_,​Score_>

- All Implemented Interfaces:
    `InnerScoreDirectorFactory<Solution_,​Score_>`, `ScoreDirectorFactory<Solution_>`

      public class TestGenDroolsScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>
      extends DroolsScoreDirectorFactory<Solution_,​Score_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.drools.DroolsScoreDirectorFactory

      `ruleToConstraintWeightExtractorMap`

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertClonedSolution, assertionScoreDirectorFactory, initializingScoreTrend, logger, solutionDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TestGenDroolsScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor, org.kie.api.KieBase kieBase, List<String> scoreDrlList, List<File> scoreDrlFileList)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `TestGenDroolsScoreDirector<Solution_,​Score_>` | `buildScoreDirector​(boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` | Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.drools.DroolsScoreDirectorFactory

      `checkIfGlobalScoreHolderExists, createRuleToConstraintWeightExtractorMap, getRuleToConstraintWeightExtractorMap, newKieSession`

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertScoreFromScratch, buildScoreDirector, getAssertionScoreDirectorFactory, getInitializingScoreTrend, getScoreDefinition, getSolutionDescriptor, isAssertClonedSolution, setAssertClonedSolution, setAssertionScoreDirectorFactory, setInitializingScoreTrend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TestGenDroolsScoreDirectorFactory

          public TestGenDroolsScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor,
                                                   org.kie.api.KieBase kieBase,
                                                   List<String> scoreDrlList,
                                                   List<File> scoreDrlFileList)

      Parameters:
        `solutionDescriptor` - never null
        `kieBase` - never null
        `scoreDrlList` -
        `scoreDrlFileList` -

  - ### Method Detail

    - #### buildScoreDirector

          public TestGenDroolsScoreDirector<Solution_,​Score_> buildScoreDirector​(boolean lookUpEnabled,
                                                                                       boolean constraintMatchEnabledPreference)

      Description copied from interface: `InnerScoreDirectorFactory`
      Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
      Specified by:
        `buildScoreDirector` in interface `InnerScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>`
      Overrides:
        `buildScoreDirector` in class `DroolsScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>`
      Parameters:
        `lookUpEnabled` - true if a `ScoreDirector` implementation should track all working objects for `ScoreDirector.lookUpWorkingObject(Object)`
        `constraintMatchEnabledPreference` - false if a `ScoreDirector` implementation should not do `ConstraintMatch` tracking even if it supports it.
      Returns:
        never null
      See Also:
        `InnerScoreDirector.isConstraintMatchEnabled()`, `InnerScoreDirector.getConstraintMatchTotalMap()`